function Generate_Simulated_GASA(f, g, repeats);

workstation_dir='/home/gshieh3/Simulated/';
main_dir=pwd;
file_dir=[main_dir '/GASA_Code/'];
file_list{1,1}='a.out';
file_list{2,1}='My_Graph.py';
file_list{3,1}='My_Sub.py';
file_list{4,1}='pexpect.py';
file_list{5,1}='regression.py';
file_list{6,1}='ReportGeneration_v2.py';

SNR=input('SNR = ');

for i=1:repeats
    [Simulated_g]=Generate_Simulated_Data(f, g, SNR);
    sub_dir=['Case_' num2str(i, '%02.0f') '/'];
    mkdir(sub_dir);
    cd(sub_dir);
    fid_GA=fopen('GA.sh','w+');
    for j=1:4
        switch j
            case 2
                case_dir='AIC/';
                file_list{7,1}='GeneNet_TrueModel_self_family_factor_GreedyV4AICSSEVAR_Stat_SchemeThree.py';
            case 1
                case_dir='AIC_woPower/';
                file_list{7,1}='GeneNet_TrueModel_self_family_factor_GreedyV4AICSSEVARwoPower_Stat_SchemeThree.py';
            case 4
                case_dir='BIC/';
                file_list{7,1}='GeneNet_TrueModel_self_family_factor_GreedyV4BICSSEVAR_Stat_SchemeThree.py';
            case 3
                case_dir='BIC_woPower/';
                file_list{7,1}='GeneNet_TrueModel_self_family_factor_GreedyV4BICSSEVARwoPower_Stat_SchemeThree.py';
        end
        mkdir(case_dir);
        cd(case_dir);
        for k=1:7
            copyfile([file_dir file_list{k,1}],'./');
        end
        
        fid=fopen('Simulated_Data.txt','w+');
        expression_data=[f; Simulated_g];
        for x=1:size(expression_data,1)
            for y=1:size(expression_data,2)
                fprintf(fid,'%f',expression_data(x,y));
                if y==size(expression_data,2)
                    break;
                end
                fprintf(fid,'	');
            end
            fprintf(fid,'\n');
        end
        fclose(fid);
        
        fid=fopen('Simulated_Data.txtt','w+');
        expression_data=[f; Simulated_g]';
        for x=1:size(expression_data,1)
            for y=1:size(expression_data,2)
                fprintf(fid,'%f',expression_data(x,y));
                if y==size(expression_data,2)
                    break;
                end
                fprintf(fid,'	');
            end
            fprintf(fid,'\n');
        end
        fclose(fid);
        
        fid=fopen('Simulated_Data_Name.txt','w+');
        fprintf(fid,'F1\nF2\nG1\nG2\nG3\nG4\nG5\nG6\nG7\nG8\nG9\nG10\nG11\n');
        fclose(fid);
        
        switch j
            case 2
                fid_GA_case=fopen('GA_AIC.sh','w+');
            case 1
                fid_GA_case=fopen('GA_AIC_woPower.sh','w+');
                
                fprintf(fid_GA,'cd "%s%s%s"\n',workstation_dir,sub_dir,case_dir);
                fprintf(fid_GA,'qsub GA_AIC_woPower.sh\n');
            case 4
                fid_GA_case=fopen('GA_BIC.sh','w+');
            case 3
                fid_GA_case=fopen('GA_BIC_woPower.sh','w+');
        end
        if j==1
            fprintf(fid_GA_case,'#PBS -N %s\n',sub_dir(1:end-1));
            fprintf(fid_GA_case,'#PBS -l nodes=1:ppn=1\n');
            fprintf(fid_GA_case,'#PBS -e GA_%s.e\n',case_dir(1:end-1));
            fprintf(fid_GA_case,'#PBS -o GA_%s.o\n',case_dir(1:end-1));
        end
        
        fprintf(fid_GA_case,'cd "%s%s%s"\n',workstation_dir,sub_dir,case_dir);
        fprintf(fid_GA_case,'chmod 775 a.out\n');
        if j==1
            fprintf(fid_GA_case,'echo "Job AIC_woPower started at `date`"\n');
            fprintf(fid_GA_case,'python %s Simulated_Data.txtt\n',file_list{7,1});
            fprintf(fid_GA_case,'echo "Job AIC_woPower ended at `date`"\n');
            fprintf(fid_GA_case,'cd "%s%sAIC/"\n',workstation_dir,sub_dir);
            fprintf(fid_GA_case,'echo "Job AIC started at `date`"\n');
            fprintf(fid_GA_case,'sh GA_AIC.sh\n');
            fprintf(fid_GA_case,'echo "Job AIC ended at `date`"\n');
            fprintf(fid_GA_case,'cd "%s%sBIC/"\n',workstation_dir,sub_dir);
            fprintf(fid_GA_case,'echo "Job BIC started at `date`"\n');
            fprintf(fid_GA_case,'sh GA_BIC.sh\n');
            fprintf(fid_GA_case,'echo "Job BIC ended at `date`"\n');
            fprintf(fid_GA_case,'cd "%s%sBIC_woPower/"\n',workstation_dir,sub_dir);
            fprintf(fid_GA_case,'echo "Job BIC_woPower started at `date`"\n');
            fprintf(fid_GA_case,'sh GA_BIC_woPower.sh\n');
            fprintf(fid_GA_case,'echo "Job BIC_woPower ended at `date`"\n');
        else
            switch j
                case 2
                    fprintf(fid_GA_case,'echo "Job AIC started at `date`"\n');
                    fprintf(fid_GA_case,'python %s Simulated_Data.txtt\n',file_list{7,1});
                    fprintf(fid_GA_case,'echo "Job AIC ended at `date`"\n');
                case 3
                    fprintf(fid_GA_case,'echo "Job BIC started at `date`"\n');
                    fprintf(fid_GA_case,'python %s Simulated_Data.txtt\n',file_list{7,1});
                    fprintf(fid_GA_case,'echo "Job BIC ended at `date`"\n');
                case 4
                    fprintf(fid_GA_case,'echo "Job BIC_woPower started at `date`"\n');
                    fprintf(fid_GA_case,'python %s Simulated_Data.txtt\n',file_list{7,1});
                    fprintf(fid_GA_case,'echo "Job BIC_woPower ended at `date`"\n');
            end
        end
        fclose(fid_GA_case);
        
        cd ..
    end
    
    fclose(fid_GA);
    
    cd ..
end