function [Data, Target]=Generate_GASA(Data, Target,All_TF);
method_selection=input('[1] AIC / [2] BIC ? ');
power_selection=input('[1] Power / [2] wo Power ? ');
max_link=input('Max Incoming Links = ');
max_candidate_TFs=input('Max Candidate TFs = ');
max_true_links=input('Max True Links (fixed T/F) [0, Random] = ');
fprintf('Consider targets that have more then ? known TFs [0, skip]: \n');
consider_amount_up=input('Upper Bound: ');
consider_amount_low=input('Lower Bound: ');
workstation_dir='/home/gshieh3/runexample2-5/';
file_dir='./GASA_Code/';
file_list{1,1}='a.out';
file_list{2,1}='My_Graph.py';
file_list{3,1}='My_Sub.py';
file_list{4,1}='pexpect.py';
file_list{5,1}='regression.py';
file_list{6,1}='ReportGeneration_v2.py';
switch method_selection
    case 1
        switch power_selection
            case 1
                file_list{7,1}='GeneNet_TrueModel_self_family_factor_GreedyV4AICSSEVAR_Stat_SchemeThree.py';
            case 2
                file_list{7,1}='GeneNet_TrueModel_self_family_factor_GreedyV4AICSSEVARwoPower_Stat_SchemeThree.py';
        end
    case 2
        switch power_selection
            case 1
                file_list{7,1}='GeneNet_TrueModel_self_family_factor_GreedyV4BICSSEVAR_Stat_SchemeThree.py';
            case 2
                file_list{7,1}='GeneNet_TrueModel_self_family_factor_GreedyV4BICSSEVARwoPower_Stat_SchemeThree.py';
        end
end

fid_GA=fopen(['GA.sh'],'w+');
fprintf(fid_GA,'#PBS -N GA\n');
fprintf(fid_GA,'#PBS -l nodes=1:ppn=1\n');
fprintf(fid_GA,'#PBS -e GA.e\n');
fprintf(fid_GA,'#PBS -o GA.o\n');

for i=1:size(Target,1)
    if max_true_links>size(Target{i,1}.TFs,1)
        continue;
    end
    if (consider_amount_up<=size(Target{i,1}.TFs,1) || consider_amount_low>=size(Target{i,1}.TFs,1)) && consider_amount_up~=0 && consider_amount_up~=0
        continue;
    end
    new_max_link=max_link;
    Target_Name=Target{i,1}.Name;
    fail=1;
    while fail
        Target_Name_Index=find(strcmp(Data.Alpha.GeneName,Target_Name));
        if size(Target_Name_Index,1)>0
            fail=0;
            fprintf('Expression data of Target Gene %s is found!\n',Target_Name{1,1}); 
            break;
        else
            Target_Name=input(['1. Unable to locate gene ' Target_Name ', please enter an alias name and try again:'],'s');
        end
    end
    Target{i,1}.Name=Target_Name;
    if size(Target_Name_Index,1)>1
        Expression_Target_Multiple=[Data.Alpha.GeneExp(Target_Name_Index,:)...
                                    Data.Cdc15.GeneExp(Target_Name_Index,:)...
                                    Data.Cdc28.GeneExp(Target_Name_Index,:)];
        Expression_Target=mean(Expression_Target_Multiple);
    else
        Expression_Target=[Data.Alpha.GeneExp(Target_Name_Index,:)...
                           Data.Cdc15.GeneExp(Target_Name_Index,:)...
                           Data.Cdc28.GeneExp(Target_Name_Index,:)];
    end
    
    
    Number_of_TFs=size(Target{i,1}.TFs,1);
    new_max_link=Number_of_TFs;     %% use known_links as max incoming link
    if (new_max_link<4)
        new_max_link=4;
    end
    %%if Number_of_TFs<5
        %%new_max_candidate_TFs=Number_of_TFs+1;
    %%else
        %%new_max_candidate_TFs=max_candidate_TFs;
    %%end
    %%if max_true_links==0
        %%Random_Number_of_True_Links=int32(rand*(new_max_candidate_TFs));
        %%if Random_Number_of_True_Links>min([new_max_candidate_TFs-1 Number_of_TFs])
            %%Random_Number_of_True_Links=new_max_candidate_TFs-1;
        %%end
        %%if Random_Number_of_True_Links==0 && new_max_candidate_TFs>=5
            %%Random_Number_of_True_Links=1;
        %%end
        %%if new_max_link>new_max_candidate_TFs
            %%new_max_link=new_max_candidate_TFs;
        %%end
        %%Random_Number_of_False_Links=new_max_candidate_TFs-Random_Number_of_True_Links;
    %%else
        %%Random_Number_of_True_Links=max_true_links;
        %%Random_Number_of_False_Links=max_true_links;
    %%end
    %%fprintf('Number of true links = %d\n',Random_Number_of_True_Links);
    %%fprintf('Number of false links = %d\n',Random_Number_of_False_Links);
    
    Random_Number_of_True_Links=Number_of_TFs;
    Random_Number_of_False_Links=181-Number_of_TFs;
    Expression_True_TFs=[];
    True_TFs_Name={};
    for j=1:Random_Number_of_True_Links
        
        fail=1;
        while fail
            %%Random_Index=1+int32(rand*(Number_of_TFs-1));
            Random_Index=j;
            TFs_Name=Target{i,1}.TFs{Random_Index,1};
            Exist1=find(strcmp(True_TFs_Name,TFs_Name));
            %%Exist2=find(strcmp(Target{i,1}.Name,TFs_Name));
            %%if size(Exist1,1)==0 && size(Exist2,1)==0
            if size(Exist1,1)==0
                fail=0;
            end
        end
        True_TFs_Name{j,1}=Target{i,1}.TFs{Random_Index,1};

        fail=1;
        while fail
            TFs_Name_Index=find(strcmp(All_TF,TFs_Name));
            if size(TFs_Name_Index,1)>0
                fail=0;
                fprintf('TF %s is in 181 TFs!\n',TFs_Name); 
                break;
            else
                TFs_Name=input(['2. Unable to locate TF ' TFs_Name ', please enter an alias name and try again:'],'s');
            end
        end

        fail=1;
        while fail
            TFs_Name_Index=find(strcmp(Data.Alpha.GeneName,TFs_Name));
            if size(TFs_Name_Index,1)>0
                fail=0;
                fprintf('Expression data of TF %s is found!\n',TFs_Name); 
                break;
            else
                TFs_Name=input(['3. Unable to locate TF ' TFs_Name ', please enter an alias name and try again:'],'s');
            end
        end
        Target{i,1}.TFs{Random_Index,1}=TFs_Name;
        if size(TFs_Name_Index,1)>1
            Expression_True_TFs_Multiple=[Data.Alpha.GeneExp(TFs_Name_Index,:)...
                                          Data.Cdc15.GeneExp(TFs_Name_Index,:)...
                                          Data.Cdc28.GeneExp(TFs_Name_Index,:)];
            Expression_True_TFs(j,:)=mean(Expression_True_TFs_Multiple);
        else
            Expression_True_TFs(j,:)=[Data.Alpha.GeneExp(TFs_Name_Index,:)...
                                      Data.Cdc15.GeneExp(TFs_Name_Index,:)...
                                      Data.Cdc28.GeneExp(TFs_Name_Index,:)];
        end
    end
    
    Expression_False_TFs=[];
    False_TFs_Name={};
    for j=1:Random_Number_of_False_Links
        fail=1;
        x=1;
        while fail
            %%Random_Index=int32(rand*200);
            Random_Index=x;
            x=x+1;
            if Random_Index>181
                Random_Index=181;
            end
            if Random_Index<1
                Random_Index=1;
            end
            TFs_Name=All_TF{Random_Index,1};
            fprintf('%d %d\n',size(False_TFs_Name,1),size(True_TFs_Name,1));
            %%TFs_Name=Data.Alpha.GeneName{Random_Index,1};
            Exist1=find(strcmp(Target{i,1}.TFs,TFs_Name));
            %%Exist2=find(strcmp(Target{i,1}.Name,TFs_Name));
            Exist3=find(strcmp(False_TFs_Name,TFs_Name));
            if size(Exist1,1)==0 && size(Exist3,1)==0
                fail=0;
            end
        end
        False_TFs_Name{j,1}=Data.Alpha.GeneName{Random_Index,1};
                
        fail=1;
        while fail
            TFs_Name_Index=find(strcmp(Data.Alpha.GeneName,TFs_Name));
            if size(TFs_Name_Index,1)>0
                fail=0;
                fprintf('Expression data of Gene %s is found!\n',TFs_Name); 
                break;
            else
                TFs_Name=input(['4. Unable to locate Gene ' TFs_Name ', please enter an alias name and try again:'],'s');
            end
        end
        Data.Alpha.GeneName{Random_Index,1}=TFs_Name;
        False_TFs_Name{j,1}=TFs_Name;
        if size(TFs_Name_Index,1)>1
            Expression_False_TFs_Multiple=[Data.Alpha.GeneExp(TFs_Name_Index,:)...
                                           Data.Cdc15.GeneExp(TFs_Name_Index,:)...
                                           Data.Cdc28.GeneExp(TFs_Name_Index,:)];
            Expression_False_TFs(j,:)=mean(Expression_False_TFs_Multiple);
        else
            Expression_False_TFs(j,:)=[Data.Alpha.GeneExp(TFs_Name_Index,:)...
                                       Data.Cdc15.GeneExp(TFs_Name_Index,:)...
                                       Data.Cdc28.GeneExp(TFs_Name_Index,:)];
        end
    end
    
    for x=0:0
        Target_dir=[Target_Name{1,1} '_' num2str(Random_Number_of_True_Links) '_' num2str(Random_Number_of_False_Links) '_MAX_' num2str(new_max_link+x)];
        mkdir(Target_dir);
        for j=1:7
            copyfile([file_dir file_list{j,1}],['./' Target_dir]);
        end

        fid=fopen(['./' Target_dir '/' file_list{7,1}],'r+');
        while true
            tline=fgetl(fid);
            check_flag=strfind(tline,'N_FACTOR');
            if size(check_flag,1)>0
                if Random_Number_of_True_Links+Random_Number_of_False_Links>=10
                    back_flag=1;
                else
                    back_flag=0;
                end
                fseek(fid,ftell(fid)-3-back_flag,'bof');
                fprintf(fid,'%d',Random_Number_of_True_Links+Random_Number_of_False_Links);
                tline=fgetl(fid);
                tline=fgetl(fid);
                if new_max_link+x>=10
                    back_flag=1;
                else
                    back_flag=0;
                end
                fseek(fid,ftell(fid)-3-back_flag,'bof');
                fprintf(fid,'%d',new_max_link+x);
                fclose(fid);
                break;
            end
        end

        fid=fopen(['./' Target_dir '/' Target_Name{1,1} '.names.txt'],'w+');
        for j=1:Random_Number_of_True_Links
            fprintf(fid,'%s\n',True_TFs_Name{j,1});
        end
        for j=1:Random_Number_of_False_Links
            fprintf(fid,'%s\n',False_TFs_Name{j,1});
        end
        fprintf(fid,'%s',Target_Name{1,1});
        fclose(fid);

        Expression_All=[Expression_True_TFs; Expression_False_TFs; Expression_Target];

        fid=fopen(['./' Target_dir '/' Target_Name{1,1} '.exp.txt'],'w+');
        for j=1:size(Expression_All,1)
            for k=1:size(Expression_All,2)
                fprintf(fid,'%f\t',Expression_All(j,k));
            end
            fprintf(fid,'\n');
        end
        fclose(fid);

        Expression_All_t=Expression_All';

        fid=fopen(['./' Target_dir '/' Target_Name{1,1} '.exp.txtt'],'w+');
        for j=1:size(Expression_All_t,1)
            for k=1:size(Expression_All_t,2)
                fprintf(fid,'%f\t',Expression_All_t(j,k));
            end
            fprintf(fid,'\n');
        end
        fclose(fid);

        fprintf(fid_GA,'cd "%s%s/"\n',workstation_dir,Target_dir);
        fprintf(fid_GA,'chmod 775 a.out\n');
        fprintf(fid_GA,'echo "Job %s started at `date`"\n',Target_Name{1,1});
        fprintf(fid_GA,'python %s %s.exp.txtt\n',file_list{7,1},Target_Name{1,1});
        fprintf(fid_GA,'echo "Job %s ended at `date`"\n',Target_Name{1,1});
        fprintf(fid_GA,'cd ".."\n');

        fprintf('\n');
    end
end
fclose(fid_GA);
fclose('all');